local addon, GW = ...

--hold backup settings in case the user cancelles the changes
GW.backupSettings = {}

--hold current anchor for easy access
GW.anchor = "TOPLEFT"

--creates the options interface
function GW.buildOpt()
	--context
	GW.optionContext = UI.CreateContext(addon.identifier)
	
	--the options frame, modeled after a RiftWindow
	GW.UI.OPT.frame = UI.CreateFrame("RiftWindow", "GW.UI.OPT.frame", GW.optionContext)
	GW.UI.OPT.frame:SetWidth(600)
	GW.UI.OPT.frame:SetHeight(600)
	GW.UI.OPT.frame:SetLayer(1)
	GW.UI.OPT.frame:SetTitle("GroupWatch Config")
	GW.UI.OPT.frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 500, 250)
	GW.UI.OPT.frame:SetVisible(false)
	--events for dragging
	GW.UI.OPT.frame:GetBorder():EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - GW.UI.OPT.frame:GetLeft()
		self.sy = mouseData.y - GW.UI.OPT.frame:GetTop()
		self.MouseDown = true
	end, "Event.UI.Input.Mouse.Left.Down")
	GW.UI.OPT.frame:GetBorder():EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
		self.MouseDown = false
	end, "Event.UI.Input.Mouse.Left.Up")
	GW.UI.OPT.frame:GetBorder():EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
		if self.MouseDown then
			local mouseData = Inspect.Mouse()
			GW.UI.OPT.frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", mouseData.x - self.sx, mouseData.y - self.sy)
		end
	end, "Event.UI.Input.Mouse.Cursor.Move")
	
	--close button, closes the options frame and reverts to backup settings
	--[[GW.UI.OPT.close = UI.CreateFrame("RiftButton", "GW.UI.OPT.close", GW.UI.OPT.frame)
	GW.UI.OPT.close:SetSkin("close")
	GW.UI.OPT.close:SetPoint("TOPRIGHT", GW.UI.OPT.frame, "TOPRIGHT", -8, 16)
	GW.UI.OPT.close:SetLayer(3)
	GW.UI.OPT.close:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		GW.UI.OPT.frame:SetVisible(false)
		GW.UI.SET.frame:SetVisible(false)
		GW.UI.SET.macro:SetKeyFocus(false)
		GW.finishEditing()
		GW.UI.handle:SetVisible(false)
		GW.updateGroup()
	end, "Event.UI.Input.Mouse.Left.Click")]]--
	
	--label for changing the frame width
	GW.UI.OPT.widthText = UI.CreateFrame("Text", "GW.UI.OPT.widthText", GW.UI.OPT.frame)
	GW.UI.OPT.widthText:SetWidth(200)
	GW.UI.OPT.widthText:SetHeight(25)
	GW.UI.OPT.widthText:SetFontSize(12)
	GW.UI.OPT.widthText:SetFontColor(1,1,0)
	GW.UI.OPT.widthText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.widthText:SetText("Frame Width: ")
	GW.UI.OPT.widthText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 50)
	--slider for changing the frame width
	GW.UI.OPT.width = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.width", GW.UI.OPT.frame)
	GW.UI.OPT.width:SetWidth(200)
	GW.UI.OPT.width:SetHeight(25)
	GW.UI.OPT.width:SetRange(20, 200)
	GW.UI.OPT.width:SetPosition(GW.settings.width, true)
	GW.UI.OPT.width:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 75)
	function GW.UI.OPT.width.Event:SliderChange()
		GW.setFrameWidth(GW.UI.OPT.width:GetPosition())
		GW.updateFramePositions()
	end
	
	--label for changing the healthbar height
	GW.UI.OPT.healthText = UI.CreateFrame("Text", "GW.UI.OPT.healthText", GW.UI.OPT.frame)
	GW.UI.OPT.healthText:SetWidth(200)
	GW.UI.OPT.healthText:SetHeight(25)
	GW.UI.OPT.healthText:SetFontSize(12)
	GW.UI.OPT.healthText:SetFontColor(1,1,0)
	GW.UI.OPT.healthText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.healthText:SetText("Healthbar Height: ")
	GW.UI.OPT.healthText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 100)
	--slider for changing the healthbar height
	GW.UI.OPT.health = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.health", GW.UI.OPT.frame)
	GW.UI.OPT.health:SetWidth(200)
	GW.UI.OPT.health:SetHeight(25)
	GW.UI.OPT.health:SetRange(0, 50)
	GW.UI.OPT.health:SetPosition(GW.settings.health, true)
	GW.UI.OPT.health:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 125)
	function GW.UI.OPT.health.Event:SliderChange()
		GW.setHealthHeight(GW.UI.OPT.health:GetPosition())
		GW.updateFramePositions()
	end
	
	--label for changing the manabar height
	GW.UI.OPT.manaText = UI.CreateFrame("Text", "GW.UI.OPT.manaText", GW.UI.OPT.frame)
	GW.UI.OPT.manaText:SetWidth(200)
	GW.UI.OPT.manaText:SetHeight(25)
	GW.UI.OPT.manaText:SetFontSize(12)
	GW.UI.OPT.manaText:SetFontColor(1,1,0)
	GW.UI.OPT.manaText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.manaText:SetText("Manabar Height: ")
	GW.UI.OPT.manaText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 150)
	--slider for changing the manabar height
	GW.UI.OPT.mana = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.mana", GW.UI.OPT.frame)
	GW.UI.OPT.mana:SetWidth(200)
	GW.UI.OPT.mana:SetHeight(25)
	GW.UI.OPT.mana:SetRange(0, 50)
	GW.UI.OPT.mana:SetPosition(GW.settings.mana, true)
	GW.UI.OPT.mana:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 175)
	function GW.UI.OPT.mana.Event:SliderChange()
		GW.setManaHeight(GW.UI.OPT.mana:GetPosition())
		GW.updateFramePositions()
	end
	
	--label for changing the targetbar height
	GW.UI.OPT.targetText = UI.CreateFrame("Text", "GW.UI.OPT.targetText", GW.UI.OPT.frame)
	GW.UI.OPT.targetText:SetWidth(200)
	GW.UI.OPT.targetText:SetHeight(25)
	GW.UI.OPT.targetText:SetFontSize(12)
	GW.UI.OPT.targetText:SetFontColor(1,1,0)
	GW.UI.OPT.targetText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.targetText:SetText("Targetbar Height: ")
	GW.UI.OPT.targetText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 200)
	--slider for changing the targetbar height
	GW.UI.OPT.target = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.target", GW.UI.OPT.frame)
	GW.UI.OPT.target:SetWidth(200)
	GW.UI.OPT.target:SetHeight(25)
	GW.UI.OPT.target:SetRange(0, 50)
	GW.UI.OPT.target:SetPosition(GW.settings.target, true)
	GW.UI.OPT.target:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 225)
	function GW.UI.OPT.target.Event:SliderChange()
		GW.setTargetHeight(GW.UI.OPT.target:GetPosition())
		GW.updateFramePositions()
	end
	
	---------------------------------------
	
	--label for changing the timerbar height
	GW.UI.OPT.timerText = UI.CreateFrame("Text", "GW.UI.OPT.timerText", GW.UI.OPT.frame)
	GW.UI.OPT.timerText:SetWidth(200)
	GW.UI.OPT.timerText:SetHeight(25)
	GW.UI.OPT.timerText:SetFontSize(12)
	GW.UI.OPT.timerText:SetFontColor(1,1,0)
	GW.UI.OPT.timerText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.timerText:SetText("Timerbar Height: ")
	GW.UI.OPT.timerText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 50)
	--slider for changing the timerbar height
	GW.UI.OPT.timer = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.timer", GW.UI.OPT.frame)
	GW.UI.OPT.timer:SetWidth(200)
	GW.UI.OPT.timer:SetHeight(25)
	GW.UI.OPT.timer:SetRange(0, 50)
	GW.UI.OPT.timer:SetPosition(GW.settings.timer, true)
	GW.UI.OPT.timer:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 75)
	function GW.UI.OPT.timer.Event:SliderChange()
		GW.setTimerHeight(GW.UI.OPT.timer:GetPosition())
		GW.updateFramePositions()
	end
	
	--label for changing the number of timerbars
	GW.UI.OPT.timersText = UI.CreateFrame("Text", "GW.UI.OPT.timersText", GW.UI.OPT.frame)
	GW.UI.OPT.timersText:SetWidth(200)
	GW.UI.OPT.timersText:SetHeight(25)
	GW.UI.OPT.timersText:SetFontSize(12)
	GW.UI.OPT.timersText:SetFontColor(1,1,0)
	GW.UI.OPT.timersText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.timersText:SetText("Timerbar count: ")
	GW.UI.OPT.timersText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 100)
	--slider for changing the number of timerbars
	GW.UI.OPT.timers = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.timers", GW.UI.OPT.frame)
	GW.UI.OPT.timers:SetWidth(200)
	GW.UI.OPT.timers:SetHeight(25)
	GW.UI.OPT.timers:SetRange(0, GW.maxTimers)
	GW.UI.OPT.timers:SetPosition(GW.settings.timers, true)
	GW.UI.OPT.timers:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 125)
	function GW.UI.OPT.timers.Event:SliderChange()
		GW.setTimerCount(GW.UI.OPT.timers:GetPosition())
		GW.updateFramePositions()
	end
	
	--label for changing the size of the buttons
	GW.UI.OPT.buttonText = UI.CreateFrame("Text", "GW.UI.OPT.buttonText", GW.UI.OPT.frame)
	GW.UI.OPT.buttonText:SetWidth(200)
	GW.UI.OPT.buttonText:SetHeight(25)
	GW.UI.OPT.buttonText:SetFontSize(12)
	GW.UI.OPT.buttonText:SetFontColor(1,1,0)
	GW.UI.OPT.buttonText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.buttonText:SetText("Button Size: ")
	GW.UI.OPT.buttonText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 150)
	--slider for changing the size of the buttons
	GW.UI.OPT.button = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.button", GW.UI.OPT.frame)
	GW.UI.OPT.button:SetWidth(200)
	GW.UI.OPT.button:SetHeight(25)
	GW.UI.OPT.button:SetRange(0, 50)
	GW.UI.OPT.button:SetPosition(GW.settings.button, true)
	GW.UI.OPT.button:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 175)
	function GW.UI.OPT.button.Event:SliderChange()
		GW.setButtonSize(GW.UI.OPT.button:GetPosition())
		GW.updateFramePositions()
	end
	
	--label for changing the number of rows of buttons
	GW.UI.OPT.buttonsText = UI.CreateFrame("Text", "GW.UI.OPT.buttonsText", GW.UI.OPT.frame)
	GW.UI.OPT.buttonsText:SetWidth(200)
	GW.UI.OPT.buttonsText:SetHeight(25)
	GW.UI.OPT.buttonsText:SetFontSize(12)
	GW.UI.OPT.buttonsText:SetFontColor(1,1,0)
	GW.UI.OPT.buttonsText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.buttonsText:SetText("Button Rows: " )
	GW.UI.OPT.buttonsText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 200)
	--slider for changing the number of rows of buttons
	GW.UI.OPT.buttons = UI.CreateFrame("SimpleSlider", "GW.UI.OPT.buttons", GW.UI.OPT.frame)
	GW.UI.OPT.buttons:SetWidth(200)
	GW.UI.OPT.buttons:SetHeight(25)
	GW.UI.OPT.buttons:SetRange(0, 2)
	GW.UI.OPT.buttons:SetPosition(GW.settings.buttons, true)
	GW.UI.OPT.buttons:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 225)
	function GW.UI.OPT.buttons.Event:SliderChange()
		GW.setButtonCount(GW.UI.OPT.buttons:GetPosition())
		GW.updateFramePositions()
	end
	
	---------------------------------------
	
	--label for changing the hoizontal growth direction
	GW.UI.OPT.growthXText = UI.CreateFrame("Text", "GW.UI.OPT.growthXText", GW.UI.OPT.frame)
	GW.UI.OPT.growthXText:SetWidth(200)
	GW.UI.OPT.growthXText:SetHeight(25)
	GW.UI.OPT.growthXText:SetFontSize(12)
	GW.UI.OPT.growthXText:SetFontColor(1,1,0)
	GW.UI.OPT.growthXText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.growthXText:SetText("Horizontal Growth: " )
	GW.UI.OPT.growthXText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 250)
	--slider for changing the number of rows of buttons
	GW.UI.OPT.growthX = UI.CreateFrame("SimpleSelect", "GW.UI.OPT.growthX", GW.UI.OPT.frame)
	GW.UI.OPT.growthX:SetItems({"Right","Left"}, {1,-1})
	GW.UI.OPT.growthX:SetSelectedValue(GW.settings.growthX, true)
	GW.UI.OPT.growthX:SetWidth(200)
	GW.UI.OPT.growthX:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 275)
	function GW.UI.OPT.growthX.Event:ItemSelect(item, value, index)
		GW.settings.growthX = value
		GW.updateFramePositions()
	end
	
	--label for changing the vertical growth direction
	GW.UI.OPT.growthYText = UI.CreateFrame("Text", "GW.UI.OPT.growthYText", GW.UI.OPT.frame)
	GW.UI.OPT.growthYText:SetWidth(200)
	GW.UI.OPT.growthYText:SetHeight(25)
	GW.UI.OPT.growthYText:SetFontSize(12)
	GW.UI.OPT.growthYText:SetFontColor(1,1,0)
	GW.UI.OPT.growthYText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.growthYText:SetText("Vertical Growth: " )
	GW.UI.OPT.growthYText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 300)
	--slider for changing the number of rows of buttons
	GW.UI.OPT.growthY = UI.CreateFrame("SimpleSelect", "GW.UI.OPT.growthY", GW.UI.OPT.frame)
	GW.UI.OPT.growthY:SetItems({"Down","Up"}, {1,-1})
	GW.UI.OPT.growthY:SetSelectedValue(GW.settings.growthY, true)
	GW.UI.OPT.growthY:SetWidth(200)
	GW.UI.OPT.growthY:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 325)
	function GW.UI.OPT.growthY.Event:ItemSelect(item, value, index)
		GW.settings.growthY = value
		GW.updateFramePositions()
	end
	
	--label for changing the party growth direction
	GW.UI.OPT.growthDirText = UI.CreateFrame("Text", "GW.UI.OPT.growthDirText", GW.UI.OPT.frame)
	GW.UI.OPT.growthDirText:SetWidth(200)
	GW.UI.OPT.growthDirText:SetHeight(25)
	GW.UI.OPT.growthDirText:SetFontSize(12)
	GW.UI.OPT.growthDirText:SetFontColor(1,1,0)
	GW.UI.OPT.growthDirText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.growthDirText:SetText("Growth Priority: " )
	GW.UI.OPT.growthDirText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 250)
	--slider for changing the number of rows of buttons
	GW.UI.OPT.growthDir = UI.CreateFrame("SimpleSelect", "GW.UI.OPT.growthDir", GW.UI.OPT.frame)
	GW.UI.OPT.growthDir:SetItems({"Vertical","Horizontal"}, {1,-1})
	GW.UI.OPT.growthDir:SetSelectedValue(GW.settings.growthDir, true)
	GW.UI.OPT.growthDir:SetWidth(200)
	GW.UI.OPT.growthDir:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 275)
	function GW.UI.OPT.growthDir.Event:ItemSelect(item, value, index)
		GW.settings.growthDir = value
		GW.updateFramePositions()
	end
	
	--label for changing the party growth direction
	GW.UI.OPT.layoutText = UI.CreateFrame("Text", "GW.UI.OPT.layoutText", GW.UI.OPT.frame)
	GW.UI.OPT.layoutText:SetWidth(200)
	GW.UI.OPT.layoutText:SetHeight(25)
	GW.UI.OPT.layoutText:SetFontSize(12)
	GW.UI.OPT.layoutText:SetFontColor(1,1,0)
	GW.UI.OPT.layoutText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.layoutText:SetText("Grid Layout: ")
	GW.UI.OPT.layoutText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 300)
	--slider for changing the number of rows of buttons
	GW.UI.OPT.layout = UI.CreateFrame("SimpleSelect", "GW.UI.OPT.layout", GW.UI.OPT.frame)
	GW.UI.OPT.layout:SetItems({"5x4","4x5","10x2","2x10","20x1","1x20"}, {5,4,10,2,20,1})
	GW.UI.OPT.layout:SetSelectedValue(GW.settings.layout, true)
	GW.UI.OPT.layout:SetWidth(200)
	GW.UI.OPT.layout:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 300, 325)
	function GW.UI.OPT.layout.Event:ItemSelect(item, value, index)
		GW.settings.layout = value
		GW.updateFramePositions()
	end
	
	---------------------------------------
	
	GW.UI.OPT.visibleText = UI.CreateFrame("Text", "GW.UI.OPT.visibleText", GW.UI.OPT.frame)
	GW.UI.OPT.visibleText:SetWidth(200)
	GW.UI.OPT.visibleText:SetHeight(25)
	GW.UI.OPT.visibleText:SetFontSize(12)
	GW.UI.OPT.visibleText:SetFontColor(1,1,0)
	GW.UI.OPT.visibleText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.visibleText:SetText("When in a group: ")
	GW.UI.OPT.visibleText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 350)
	
	GW.UI.OPT.visible = UI.CreateFrame("SimpleCheckbox", "GW.UI.OPT.visible", GW.UI.OPT.frame)
	GW.UI.OPT.visible:SetWidth(200)
	GW.UI.OPT.visible:SetHeight(25)
	GW.UI.OPT.visible:SetFontSize(12)
	GW.UI.OPT.visible:SetText("Show Raid Frames")
	GW.UI.OPT.visible:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 200, 350)
	function GW.UI.OPT.visible.Event:CheckboxChange()
		if GW.silent == true then
			return
		end
		GW.settings.visible = GW.UI.OPT.visible:GetChecked()
		GW.updateGroup()
	end
	
	GW.UI.OPT.petVisible = UI.CreateFrame("SimpleCheckbox", "GW.UI.OPT.petVisible", GW.UI.OPT.frame)
	GW.UI.OPT.petVisible:SetWidth(200)
	GW.UI.OPT.petVisible:SetHeight(25)
	GW.UI.OPT.petVisible:SetFontSize(12)
	GW.UI.OPT.petVisible:SetText("Show Pet Frame")
	GW.UI.OPT.petVisible:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 350, 350)
	function GW.UI.OPT.petVisible.Event:CheckboxChange()
		if GW.silent == true then
			return
		end
		GW.settings.petVisible = GW.UI.OPT.petVisible:GetChecked()
		GW.updateGroup()
	end
	
	GW.UI.OPT.showText = UI.CreateFrame("Text", "GW.UI.OPT.showText", GW.UI.OPT.frame)
	GW.UI.OPT.showText:SetWidth(200)
	GW.UI.OPT.showText:SetHeight(25)
	GW.UI.OPT.showText:SetFontSize(12)
	GW.UI.OPT.showText:SetFontColor(1,1,0)
	GW.UI.OPT.showText:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.showText:SetText("When NOT in a group: ")
	GW.UI.OPT.showText:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 375)
	
	GW.UI.OPT.showPlayer = UI.CreateFrame("SimpleCheckbox", "GW.UI.OPT.showPlayer", GW.UI.OPT.frame)
	GW.UI.OPT.showPlayer:SetWidth(200)
	GW.UI.OPT.showPlayer:SetHeight(25)
	GW.UI.OPT.showPlayer:SetFontSize(12)
	GW.UI.OPT.showPlayer:SetText("Show Player Frame")
	GW.UI.OPT.showPlayer:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 200, 375)
	function GW.UI.OPT.showPlayer.Event:CheckboxChange()
		if GW.silent == true then
			return
		end
		GW.settings.showPlayer = GW.UI.OPT.showPlayer:GetChecked()
		GW.updateGroup()
	end
	
	GW.UI.OPT.showPet = UI.CreateFrame("SimpleCheckbox", "GW.UI.OPT.showPet", GW.UI.OPT.frame)
	GW.UI.OPT.showPet:SetWidth(200)
	GW.UI.OPT.showPet:SetHeight(25)
	GW.UI.OPT.showPet:SetFontSize(12)
	GW.UI.OPT.showPet:SetText("Show Pet Frame")
	GW.UI.OPT.showPet:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 350, 375)
	function GW.UI.OPT.showPet.Event:CheckboxChange()
		if GW.silent == true then
			return
		end
		GW.settings.showPet = GW.UI.OPT.showPet:GetChecked()
		GW.updateGroup()
	end
	
	
	--label instructing the player on how the use the addon
	GW.UI.OPT.text = UI.CreateFrame("Text", "GW.UI.OPT.text", GW.UI.OPT.frame)
	GW.UI.OPT.text:SetWidth(500)
	GW.UI.OPT.text:SetHeight(150)
	GW.UI.OPT.text:SetFontSize(12)
	GW.UI.OPT.text:SetFontColor(1,1,0)
	GW.UI.OPT.text:SetEffectGlow({strength=10, blurX=2, blurY=2})
	local text = "To move the raid frames, click and drag the large blue handle at the upper-left of the frames.\n"
	text = text.."To move the pet frame, click and drag the small blue handle at the upper-left of the pet frame.\n\n"
	text = text.."To set an ability, click on either a timerbar or a button IN THE DEMO FRAME to the right. -->\n"
	text = text.."Or, just drag an ability onto either a timerbar or a button IN THE DEMO FRAME to the right.\n\n"
	text = text.."Frames will fade out slightly when the unit is blocked, and greatly when the unit is out of range.\n"
	text = text.."Settings will automatically swap out to match your current Role. Frames will tint red with aggro.\n"
	GW.UI.OPT.text:SetText(text)
	GW.UI.OPT.text:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 400)
	
	--credits
	GW.UI.OPT.text = UI.CreateFrame("Text", "GW.UI.OPT.text", GW.UI.OPT.frame)
	GW.UI.OPT.text:SetWidth(500)
	GW.UI.OPT.text:SetHeight(150)
	GW.UI.OPT.text:SetFontSize(12)
	GW.UI.OPT.text:SetFontColor(1,1,0)
	GW.UI.OPT.text:SetEffectGlow({strength=10, blurX=2, blurY=2})
	GW.UI.OPT.text:SetText("Made by Darrek/Rannor@Deepwood")
	GW.UI.OPT.text:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 50, 560)
	
	---------------------------------------
	
	--button for completing all changes.
	GW.UI.OPT.save = UI.CreateFrame("RiftButton", "GW.UI.OPT.save", GW.UI.OPT.frame)
	GW.UI.OPT.save:SetWidth(150)
	GW.UI.OPT.save:SetHeight(40)
	GW.UI.OPT.save:SetLayer(3)
	GW.UI.OPT.save:SetText("Save")
	GW.UI.OPT.save:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 250, 550)
	GW.UI.OPT.save:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		GW.UI.OPT.frame:SetVisible(false)
		GW.UI.SET.frame:SetVisible(false)
		GW.UI.SET.macro:SetKeyFocus(false)
		GW.UI.SET.buff:SetKeyFocus(false)
		GW.finishEditing()
		GW.UI.handle:SetVisible(false)
		GW.UI.petHandle:SetVisible(false)
		GW.updateGroup()
	end, "Event.UI.Input.Mouse.Left.Click")
	
	--button for reverting all changes.
	GW.UI.OPT.cancel = UI.CreateFrame("RiftButton", "GW.UI.OPT.cancel", GW.UI.OPT.frame)
	GW.UI.OPT.cancel:SetWidth(150)
	GW.UI.OPT.cancel:SetHeight(40)
	GW.UI.OPT.cancel:SetLayer(3)
	GW.UI.OPT.cancel:SetText("Cancel")
	GW.UI.OPT.cancel:SetPoint("TOPLEFT", GW.UI.OPT.frame, "TOPLEFT", 400, 550)
	GW.UI.OPT.cancel:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		GW.UI.OPT.frame:SetVisible(false)
		GW.UI.SET.frame:SetVisible(false)
		GW.UI.SET.macro:SetKeyFocus(false)
		GW.UI.SET.buff:SetKeyFocus(false)
		GW.cancelEditing()
		GW.UI.handle:SetVisible(false)
		GW.UI.petHandle:SetVisible(false)
		GW.updateGroup()
	end, "Event.UI.Input.Mouse.Left.Click")
	
	GW.UI.OPT.testFrame = GW.createTestFrame(GW.UI.OPT.frame:GetWidth(), 50)
end

--sets the height of the healthbar
--height - the new height
function GW.setHealthHeight(height)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the height
	GW.settings.health = height
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...set the new healthbar height
		GW.UI.group[i].name:SetHeight(GW.settings.health+GW.settings.mana)
		GW.UI.group[i].name:SetFontSize(((GW.settings.health+GW.settings.mana)/2)+2)
		GW.UI.group[i].role:SetWidth(GW.UI.group[i].role:GetHeight())
		GW.UI.group[i].health:SetHeight(GW.settings.health)
		GW.UI.group[i].healthBG:SetHeight(GW.settings.health)
		GW.UI.group[i].healthbar:SetHeight(GW.settings.health)
		GW.UI.group[i].absorbbar:SetHeight(GW.settings.health)
		--and the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	--update the test frame
	GW.UI.OPT.testFrame.healthbar:SetHeight(GW.settings.health)
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the height of the manabar
--height - the new height
function GW.setManaHeight(height)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the height
	GW.settings.mana = height
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...set the new manabar height
		GW.UI.group[i].name:SetHeight(GW.settings.health+GW.settings.mana)
		GW.UI.group[i].name:SetFontSize(((GW.settings.health+GW.settings.mana)/2)+2)
		GW.UI.group[i].role:SetWidth(GW.UI.group[i].role:GetHeight())
		GW.UI.group[i].mana:SetHeight(GW.settings.mana)
		GW.UI.group[i].manaBG:SetHeight(GW.settings.mana)
		GW.UI.group[i].manabar:SetHeight(GW.settings.mana)
		--and the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	--update the test frame
	GW.UI.OPT.testFrame.manabar:SetHeight(GW.settings.mana)
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the height of each timerbar
--height - the new height
function GW.setTimerHeight(height)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the height
	GW.settings.timer = height
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...and each timerbar...
		for n=1,GW.settings.timers  do
			--...set the new timerbar height
			GW.UI.group[i].timer[n]:SetHeight(GW.settings.timer)
			GW.UI.group[i].timerBG[n]:SetHeight(GW.settings.timer)
			GW.UI.group[i].timerHover[n]:SetHeight(GW.settings.timer)
			GW.UI.group[i].timerbar[n]:SetHeight(GW.settings.timer)
		end
		--and the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	
	--update the test frame
	for n=1,GW.settings.timers  do
		GW.UI.OPT.testFrame.timerbar[n]:SetHeight(GW.settings.timer)
		GW.UI.OPT.testFrame.timerHover[n]:SetHeight(GW.settings.timer)
	end
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the number of timerbars to be displayed
--count - the new number of timerbars
function GW.setTimerCount(count)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the count
	GW.settings.timers = count
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...and each timerbar...
		for n=1,GW.maxTimers do
			--set the height to non-zero only if the timerbar is to be displayed
			if n <= GW.settings.timers then
				GW.UI.group[i].timer[n]:SetHeight(GW.settings.timer)
				GW.UI.group[i].timerBG[n]:SetHeight(GW.settings.timer)
				GW.UI.group[i].timerHover[n]:SetHeight(GW.settings.timer)
				GW.UI.group[i].timerbar[n]:SetHeight(GW.settings.timer)
			else
				GW.UI.group[i].timer[n]:SetHeight(0)
				GW.UI.group[i].timerBG[n]:SetHeight(0)
				GW.UI.group[i].timerHover[n]:SetHeight(0)
				GW.UI.group[i].timerbar[n]:SetHeight(0)
			end
		end
		--and update the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	
	--update the test frame
	for n=1,GW.maxTimers  do
		if n <= GW.settings.timers then
			GW.UI.OPT.testFrame.timerbar[n]:SetHeight(GW.settings.timer)
			GW.UI.OPT.testFrame.timerHover[n]:SetHeight(GW.settings.timer)
		else
			GW.UI.OPT.testFrame.timerbar[n]:SetHeight(0)
			GW.UI.OPT.testFrame.timerHover[n]:SetHeight(0)
		end
	end
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the size of each button
--size - the new size (in 1D, width or height)
function GW.setButtonSize(size)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the size
	GW.settings.button = size
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...and each button...
		for n=1,GW.maxButtons do
			-- set the height to non-zero only if button is on a visible row
			if (n / (GW.maxButtons/2)) <= GW.settings.buttons then
				GW.UI.group[i].buttonHover[n]:SetHeight(GW.settings.button)
				GW.UI.group[i].buttonBorder[n]:SetHeight(GW.settings.button)
				GW.UI.group[i].buttonBG[n]:SetHeight(GW.settings.button)
				GW.UI.group[i].button[n]:SetHeight(GW.settings.button)
			else
				GW.UI.group[i].buttonbar[n]:SetHeight(0)
				GW.UI.group[i].button[n]:SetHeight(0)
				GW.UI.group[i].buttonBG[n]:SetHeight(0)
				GW.UI.group[i].buttonBorder[n]:SetHeight(0)
				GW.UI.group[i].buttonHover[n]:SetHeight(0)
			end
			-- and set the width to non-zero only if button is inside frame
			if (GW.settings.button * (((n-1) % (GW.maxButtons/2))+1)) <= (GW.settings.width-(2*GW.settings.padding)) then
				GW.UI.group[i].button[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonBG[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonBorder[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonHover[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonbar[n]:SetWidth(GW.settings.button)
			else
				GW.UI.group[i].buttonbar[n]:SetWidth(0)
				GW.UI.group[i].button[n]:SetWidth(0)
				GW.UI.group[i].buttonBG[n]:SetWidth(0)
				GW.UI.group[i].buttonBorder[n]:SetWidth(0)
				GW.UI.group[i].buttonHover[n]:SetWidth(0)
				GW.UI.group[i].buttonbar[n]:SetWidth(0)
			end
		end
		--and update the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	
	--update the test frame
	for n=1,GW.maxButtons  do
		if (n / (GW.maxButtons/2)) <= GW.settings.buttons then
			GW.UI.OPT.testFrame.buttonBG[n]:SetHeight(GW.settings.button)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetHeight(GW.settings.button)
			GW.UI.OPT.testFrame.buttonHover[n]:SetHeight(GW.settings.button)
		else
			GW.UI.OPT.testFrame.buttonBG[n]:SetHeight(0)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetHeight(0)
			GW.UI.OPT.testFrame.buttonHover[n]:SetHeight(0)
		end
		if (GW.settings.button * (((n-1) % (GW.maxButtons/2))+1)) <= (GW.settings.width-(2*GW.settings.padding)) then
			GW.UI.OPT.testFrame.buttonBG[n]:SetWidth(GW.settings.button)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetWidth(GW.settings.button)
			GW.UI.OPT.testFrame.buttonHover[n]:SetWidth(GW.settings.button)
		else
			GW.UI.OPT.testFrame.buttonBG[n]:SetWidth(0)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetWidth(0)
			GW.UI.OPT.testFrame.buttonHover[n]:SetWidth(0)
		end
	end
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the number of rows of buttons to be displayed
--count - the new number of rows of buttons
function GW.setButtonCount(count)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the count
	GW.settings.buttons = count
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...and each button...
		for n=1,GW.maxButtons do
			--set the height to non-zero only if the button is on row to be displayed
			if (n / (GW.maxButtons/2)) <= GW.settings.buttons then
				GW.UI.group[i].button[n]:SetHeight(GW.settings.button)
				GW.UI.group[i].buttonBG[n]:SetHeight(GW.settings.button)
				GW.UI.group[i].buttonBorder[n]:SetHeight(GW.settings.button)
				GW.UI.group[i].buttonHover[n]:SetHeight(GW.settings.button)
			else
				GW.UI.group[i].buttonbar[n]:SetHeight(0)
				GW.UI.group[i].button[n]:SetHeight(0)
				GW.UI.group[i].buttonBG[n]:SetHeight(0)
				GW.UI.group[i].buttonBorder[n]:SetHeight(0)
				GW.UI.group[i].buttonHover[n]:SetHeight(0)
			end
		end
		--and update the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	
	for n=1,GW.maxButtons  do
		if (n / (GW.maxButtons/2)) <= GW.settings.buttons then
			GW.UI.OPT.testFrame.buttonBG[n]:SetHeight(GW.settings.button)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetHeight(GW.settings.button)
			GW.UI.OPT.testFrame.buttonHover[n]:SetHeight(GW.settings.button)
		else
			GW.UI.OPT.testFrame.buttonBG[n]:SetHeight(0)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetHeight(0)
			GW.UI.OPT.testFrame.buttonHover[n]:SetHeight(0)
		end
	end
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the height of the targetbar
--height - the new height
function GW.setTargetHeight(height)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the height
	GW.settings.target = height
	GW.UI.height = GW.makeHeight()
	
	--for each frame...
	for i=1,22 do
		--...set the new manabar height
		GW.UI.group[i].target:SetHeight(GW.settings.target)
		GW.UI.group[i].targetBG:SetHeight(GW.settings.target)
		GW.UI.group[i].targetbar:SetHeight(GW.settings.target)
		GW.UI.group[i].tabsorbbar:SetHeight(GW.settings.target)
		GW.UI.group[i].targetname:SetHeight(GW.settings.target)
		GW.UI.group[i].targetname:SetFontSize((GW.settings.target/2)+2)
		--and update the new frame height
		GW.UI.group[i].frame:SetHeight(GW.UI.height)
	end
	--update the test frame
	GW.UI.OPT.testFrame.targetbar:SetHeight(GW.settings.target)
	GW.UI.OPT.testFrame.frame:SetHeight(GW.UI.height)
end

--sets the width of each frame. This includes all contents (healthbar, manabar, etc.)
--width - the new width
function GW.setFrameWidth(width)
	--make sure the system isn't secure
	if Inspect.System.Secure() then return end
	--record the width
	GW.settings.width = width
	GW.UI.width = GW.settings.width
	
	--for each frame...
	for i=1,22 do
		--...set all of it's components' new width
		GW.UI.group[i].name:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].health:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].healthBG:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].healthbar:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].mana:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].manaBG:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].manabar:SetWidth(GW.settings.width-(2*GW.settings.padding))
		--including all timerbars
		for n=1,GW.maxTimers do
			GW.UI.group[i].timer[n]:SetWidth(GW.settings.width-(2*GW.settings.padding))
			GW.UI.group[i].timerBG[n]:SetWidth(GW.settings.width-(2*GW.settings.padding))
			GW.UI.group[i].timerHover[n]:SetWidth(GW.settings.width-(2*GW.settings.padding))
		end
		--excluding buttons (see below)
		GW.UI.group[i].target:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].targetBG:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].targetbar:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.group[i].targetname:SetWidth(GW.settings.width-(2*GW.settings.padding))
		--and update the new frame width
		GW.UI.group[i].frame:SetWidth(GW.UI.width)
	end
	
	--update the test frame
	GW.UI.OPT.testFrame.healthbar:SetWidth(GW.settings.width-(2*GW.settings.padding))
	GW.UI.OPT.testFrame.manabar:SetWidth(GW.settings.width-(2*GW.settings.padding))
	for n=1,GW.maxTimers do
		GW.UI.OPT.testFrame.timerbar[n]:SetWidth(GW.settings.width-(2*GW.settings.padding))
		GW.UI.OPT.testFrame.timerHover[n]:SetWidth(GW.settings.width-(2*GW.settings.padding))
	end
	GW.UI.OPT.testFrame.targetbar:SetWidth(GW.settings.width-(2*GW.settings.padding))
	GW.UI.OPT.testFrame.frame:SetWidth(GW.UI.width)
	
	--clip the buttons, so that any that appear outside the frame are not shown
	GW.clipButtons()
end

--tests each button to see if it is outside of it's frame, and hides it if it is
function GW.clipButtons()
	--for each frame...
	for i=1,22 do
		--...and each button...
		for n=1,GW.maxButtons  do
			--set the width to non-zero only if the button is inside the frame
			if (GW.settings.button * (((n-1) % (GW.maxButtons/2))+1)) <= (GW.settings.width-(2*GW.settings.padding)) then
				GW.UI.group[i].button[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonBG[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonBorder[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonHover[n]:SetWidth(GW.settings.button)
				GW.UI.group[i].buttonbar[n]:SetWidth(GW.settings.button)
			else
				GW.UI.group[i].button[n]:SetWidth(0)
				GW.UI.group[i].buttonBG[n]:SetWidth(0)
				GW.UI.group[i].buttonBorder[n]:SetWidth(0)
				GW.UI.group[i].buttonHover[n]:SetWidth(0)
				GW.UI.group[i].buttonbar[n]:SetWidth(0)
			end
		end
	end
	
	--update the test frame
	for n=1,GW.maxButtons  do
		if (GW.settings.button * (((n-1) % (GW.maxButtons/2))+1)) <= (GW.settings.width-(2*GW.settings.padding)) then
			GW.UI.OPT.testFrame.buttonBG[n]:SetWidth(GW.settings.button)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetWidth(GW.settings.button)
			GW.UI.OPT.testFrame.buttonHover[n]:SetWidth(GW.settings.button)
		else
			GW.UI.OPT.testFrame.buttonBG[n]:SetWidth(0)
			GW.UI.OPT.testFrame.buttonBorder[n]:SetWidth(0)
			GW.UI.OPT.testFrame.buttonHover[n]:SetWidth(0)
		end
	end
end

--repositions all frames based on their new sizes. (height/width)s
function GW.updateFramePositions()
	GW.makeAnchor()
	--for each frame...
	for i=1,20 do
		GW.updateFramePosition(i)
	end
end

function GW.makeAnchor()
	--determine anchor
	GW.anchor = ""
	if GW.settings.growthY == 1 then
		GW.anchor = "TOP"
	else
		GW.anchor = "BOTTOM"
	end
	if GW.settings.growthX == 1 then
		GW.anchor = GW.anchor.."LEFT"
	else
		GW.anchor = GW.anchor.."RIGHT"
	end
end

function GW.updateFramePosition(i)
	if GW.UI.group[i]:GetEnabled() then
		local x = GW.settings.growthX * (GW.UI.width + GW.settings.padding)
		local y =  GW.settings.growthY * (GW.UI.height + GW.settings.padding)
		
		if GW.settings.growthDir == 1 then
			--vertical growth
			x = x * math.floor((i-1) / GW.settings.layout)
			y = y * ((i-1) % GW.settings.layout)
		else
			--hoizontal growth
			x = x * ((i-1) % GW.settings.layout)
			y = y * math.floor((i-1) / GW.settings.layout)
		end
		--set the position
		GW.UI.group[i].frame:ClearPoint("TOPLEFT")
		GW.UI.group[i].frame:ClearPoint("TOPRIGHT")
		GW.UI.group[i].frame:ClearPoint("BOTTOMLEFT")
		GW.UI.group[i].frame:ClearPoint("BOTTOMRIGHT")
		GW.UI.group[i].frame:SetPoint(GW.anchor, GW.UI.handle, "CENTER", x, y)
	else
		GW.UI.group[i].frame:ClearPoint("TOPLEFT")
		GW.UI.group[i].frame:ClearPoint("TOPRIGHT")
		GW.UI.group[i].frame:ClearPoint("BOTTOMLEFT")
		GW.UI.group[i].frame:ClearPoint("BOTTOMRIGHT")
		GW.UI.group[i].frame:SetPoint("TOPLEFT", GW.UI.handle, "CENTER", 999999, 999999)
	end
end

--begins editing settings. This will store all settings in a backup variable.
--this is to be used when a reset of changes made since this call may be requested by the user.
function GW.startEditing()
	GW.backupSettings = {}
	
	GW.backupSettings.width = GW.settings.width
	GW.backupSettings.health = GW.settings.health
	GW.backupSettings.mana = GW.settings.mana
	GW.backupSettings.target = GW.settings.target
	GW.backupSettings.timer = GW.settings.timer
	GW.backupSettings.timers = GW.settings.timers
	GW.backupSettings.button = GW.settings.button
	GW.backupSettings.buttons = GW.settings.buttons
	GW.backupSettings.growthX = GW.settings.growthX
	GW.backupSettings.growthY = GW.settings.growthY
	GW.backupSettings.growthDir = GW.settings.growthDir
	GW.backupSettings.layout = GW.settings.layout
	GW.backupSettings.showPlayer = GW.settings.showPlayer
	GW.backupSettings.showPet = GW.settings.showPet
	GW.backupSettings.visible = GW.settings.visible
	GW.backupSettings.petVisible = GW.settings.petVisible
end

--stops editing, and reverts all changes to settings to their backed-up variants
function GW.cancelEditing()
	if GW.backupSettings then
		GW.silent = true
		--width
		GW.settings.width = GW.backupSettings.width
		GW.setFrameWidth(GW.settings.width)
		GW.UI.OPT.width:SetPosition(GW.settings.width, true)
		--health height
		GW.settings.health = GW.backupSettings.health
		GW.setHealthHeight(GW.settings.health)
		GW.UI.OPT.health:SetPosition(GW.settings.health, true)
		--mana height
		GW.settings.mana = GW.backupSettings.mana
		GW.setManaHeight(GW.settings.mana)
		GW.UI.OPT.mana:SetPosition(GW.settings.mana, true)
		--target height
		GW.settings.target = GW.backupSettings.target
		GW.setTargetHeight(GW.settings.target)
		GW.UI.OPT.target:SetPosition(GW.settings.target, true)
		--timer height
		GW.settings.timer = GW.backupSettings.timer
		GW.setTimerHeight(GW.settings.timer)
		GW.UI.OPT.timer:SetPosition(GW.settings.timer, true)
		--timer count
		GW.settings.timers = GW.backupSettings.timers
		GW.setTimerCount(GW.settings.timers)
		GW.UI.OPT.timers:SetPosition(GW.settings.timers, true)
		--button size
		GW.settings.button = GW.backupSettings.button
		GW.setButtonSize(GW.settings.button)
		GW.UI.OPT.button:SetPosition(GW.settings.button, true)
		--button rows
		GW.settings.buttons = GW.backupSettings.buttons
		GW.setButtonCount(GW.settings.buttons)
		GW.UI.OPT.buttons:SetPosition(GW.settings.buttons, true)
		--horizontal growth
		GW.settings.growthX = GW.backupSettings.growthX
		GW.UI.OPT.growthX:SetSelectedValue(GW.settings.growthX, true)
		--vertical growth
		GW.settings.growthY = GW.backupSettings.growthY
		GW.UI.OPT.growthY:SetSelectedValue(GW.settings.growthY, true)
		--growth direction
		GW.settings.growthDir = GW.backupSettings.growthDir
		GW.UI.OPT.growthDir:SetSelectedValue(GW.settings.growthDir, true)
		--layout
		GW.settings.layout = GW.backupSettings.layout
		GW.UI.OPT.layout:SetSelectedValue(GW.settings.layout, true)
		--show frames when raiding
		GW.settings.visible = GW.backupSettings.visible
		GW.UI.OPT.visible:SetChecked(GW.settings.visible)
		--show pet when raiding
		GW.settings.petVisible = GW.backupSettings.petVisible
		GW.UI.OPT.petVisible:SetChecked(GW.settings.petVisible)
		--show player while soloing
		GW.settings.showPlayer = GW.backupSettings.showPlayer
		GW.UI.OPT.showPlayer:SetChecked(GW.settings.showPlayer)
		--show pet while soloing
		GW.settings.showPet = GW.backupSettings.showPet
		GW.UI.OPT.showPet:SetChecked(GW.settings.showPet)
		--update positions
		GW.silent = false
		GW.updateFramePositions()
	end
end

--finished editing, saving all changes and removing the backup variable.
function GW.finishEditing()
	GW.backupSettings = nil
end