local addon, GW = ...

--default value for max health/mana. this is used when the actualy value is missing
local defaultValue = 1000

-- hold the player's ID
GW.playerID = nil
GW.petID = nil

-- hold the coordinates of the player and group members
GW.playerCoords = {}
GW.unitCoords = {
	[1] = {},
	[2] = {},
	[3] = {},
	[4] = {},
	[5] = {},
	[6] = {},
	[7] = {},
	[8] = {},
	[9] = {},
	[10] = {},
	[11] = {},
	[12] = {},
	[13] = {},
	[14] = {},
	[15] = {},
	[16] = {},
	[17] = {},
	[18] = {},
	[19] = {},
	[20] = {},
	[21] = {},
	[22] = {},
}

--hold the unit's stats. Sometimes health, mana, and energy are not available, so remeber the values from when they last were.
GW.unitStats = {
	[1] = {},
	[2] = {},
	[3] = {},
	[4] = {},
	[5] = {},
	[6] = {},
	[7] = {},
	[8] = {},
	[9] = {},
	[10] = {},
	[11] = {},
	[12] = {},
	[13] = {},
	[14] = {},
	[15] = {},
	[16] = {},
	[17] = {},
	[18] = {},
	[19] = {},
	[20] = {},
	[21] = {},
	[22] = {},
}

--also remember the health of the target for updating the target bar.
GW.targetStats = {
	[1] = {},
	[2] = {},
	[3] = {},
	[4] = {},
	[5] = {},
	[6] = {},
	[7] = {},
	[8] = {},
	[9] = {},
	[10] = {},
	[11] = {},
	[12] = {},
	[13] = {},
	[14] = {},
	[15] = {},
	[16] = {},
	[17] = {},
	[18] = {},
	[19] = {},
	[20] = {},
	[21] = {},
	[22] = {},
}

--this is used to quickly convert from a unit specifier to the group member's id
GW.geti = {
	group01 = 1,
	group02 = 2,
	group03 = 3,
	group04 = 4,
	group05 = 5,
	group06 = 6,
	group07 = 7,
	group08 = 8,
	group09 = 9,
	group10 = 10,
	group11 = 11,
	group12 = 12,
	group13 = 13,
	group14 = 14,
	group15 = 15,
	group16 = 16,
	group17 = 17,
	group18 = 18,
	group19 = 19,
	group20 = 20,
}

--to quickly convert from a group member's id to a unit specifier
GW.spec = {
	[1] = "group01",
	[2] = "group02",
	[3] = "group03",
	[4] = "group04",
	[5] = "group05",
	[6] = "group06",
	[7] = "group07",
	[8] = "group08",
	[9] = "group09",
	[10] = "group10",
	[11] = "group11",
	[12] = "group12",
	[13] = "group13",
	[14] = "group14",
	[15] = "group15",
	[16] = "group16",
	[17] = "group17",
	[18] = "group18",
	[19] = "group19",
	[20] = "group20",
	[21] = "player",
	[22] = "player.pet",
}

--icons for roles
GW.icons = {
	tank = "role_tank_big.png.dds",
	heal = "role_heal_big.png.dds",
	dps = "role_damage_big.png.dds",
	support = "role_support_big.png.dds"
}

--colors for names
GW.callings = {
	mage = {r=0.8, g=0.4, b=1}, --purple
	rogue = {r=1, g=0.8, b=0.2}, --yellow
	cleric = {r=0.4, g=1, b=0.2}, --green
	warrior = {r=1, g=0.2, b=0.2}, --red
}

GW.cleaseButtons = {}

--accurate as of 2.7
GW.cleanser = {
	AFE53E2190E6923B7 = true, -- Cleansing Rush (Chloromancer)
	A0661E099AFB3164E = true, -- Nature's Cleansing (Chloromancer)
	A11E3FAC649241796 = true, -- Cleansing Flames (Archon)
	A54DA17C39648F045 = true, -- Purification (Archon)
	A126EAD6F6DD1344E = true, -- Deny (Dominator)
	A0F447439CB2C31BB = true, -- Cauterize (Purifier)
	A2965343D52D98AB6 = true, -- Cauterizing Wave (Purifier)
	A763B186D6A4F7852 = true, -- Sterilize (Purifier)
	A1E4E7DBB72466C42 = true, -- Empowering Light (Sentinel)
	A222DD36A9C63E24B = true, -- Cleansing Prayer (Sentinel)
	A00E6951C7C1781EC = true, -- Curative Waters (Warden)
	A454FA4DE8F07DDFD = true, -- Cleansing Waters (Warden)
	AFDA8E1A7814CE00F = true, -- Jealous Intervention (Defiler)
	AFD7025D154FB9967 = true, -- Spell Destruction (Void Knight)
	A1872B8D769C37A4E = true, -- Detoxification (Physician)
	A20E068C2C0CD89F9 = true, -- Mass Detox (Physician)
	A6F2CCEA97DBDBE58 = true, -- Neutralize (Liberator)
	A21A904886D7EA283 = true, -- Counteract (Liberator)
	A5F14D3FF39C8C2C9 = true, -- Cleansing Chant (Oracle)
}

--hold indicators on whether a group member is blocked (out of line-of-sight) out of range or offline
GW.unitsBlocked = {}
GW.unitsOutOfRange = {}
GW.unitsOffline = {}

--hold a list of the player's abilities, as well as a list of the ID's using the ability name as an index
GW.abilityList = {}
GW.abilityIDs = {}

--hold information on current cooldowns.
GW.abilityCooldowns = {} --cooldowns of abilities, for buttons
GW.abilityBuffs = {} --buffs caused by abilities, for buttons (fade out when buffed or buffs tracked by name)
GW.abilityUnusable = {} --true if the ability is unusable
GW.buffTimers = {} --buff durations, for timerbars
GW.buffTracked = {} --all buffs tracked (for abilityBuffs, buffTimers, and buffWatchers)
GW.debuffTracked = {} --curse, disease, poison

--updates information on all group members when the group changes.
function GW.updateGroup()
	if not GW.enableUpdate then return end
	if LibSRM.Grouped() then
		--in a group, hide solo frames
		GW.resetGroupMember(21, "player")
		--for each group member
		for i=1,20 do
			if GW.settings.visible then
				GW.doUpdateGroup(i)
			else
				local name = "group"..i
				if i < 10 then name = "group0"..i end
				GW.resetGroupMember(i, name)
			end
		end
		if GW.settings.petVisible then
			GW.doUpdateGroup(22, GW.settings.petVisible)
		else
			GW.resetGroupMember(22, "pet")
		end
	else
		--not grouped
		for i=1,20 do
			local name = "group"..i
			if i < 10 then name = "group0"..i end
			--hide group frame
			GW.resetGroupMember(i, name)
		end
		
		if GW.settings.showPlayer then
			GW.doUpdateGroup(21)
		else
			GW.resetGroupMember(21, "player")
		end
		if GW.settings.showPet then
			GW.doUpdateGroup(22)
		else
			GW.resetGroupMember(22, "pet")
		end
	end
	GW.petID = Inspect.Unit.Lookup("player.pet")
end

function GW.updateViaSpec(event, uid, spec1, spec2)
	if LibSRM.Grouped() == true then
		if GW.settings.visible then
			GW.doUpdateGroup(GW.geti[spec1])
			if spec2 ~= nil then
				GW.doUpdateGroup(GW.geti[spec2])
			end
		end
	end
end

--updates pet information when soloing
function GW.updateAvailable(event, units)
	if units[GW.playerID] then
		GW.updateGroup()
	elseif LibSRM.Grouped() then
		if GW.settings.visible then
			for i=1,20 do
				local spec, uid = LibSRM.Group.Inspect(i)
				if units[uid] then
					GW.doUpdateGroup(i)
				end
			end
		end
		if units[Inspect.Unit.Lookup("player.pet")] then
			if GW.settings.petVisible then
				GW.doUpdateGroup(22)
				GW.petID = Inspect.Unit.Lookup("player.pet")
			else
				GW.resetGroupMember(22, "pet")
			end
		end
	elseif units[Inspect.Unit.Lookup("player.pet")] then
		if GW.settings.showPet then
			GW.doUpdateGroup(22)
			GW.petID = Inspect.Unit.Lookup("player.pet")
		else
			GW.resetGroupMember(22, "pet")
		end
	end
end

--update group helper method
function GW.doUpdateGroup(i)
	--try to inspect unit by specifier
	local unitSpec = GW.spec[i]
	local unit = Inspect.Unit.Detail(unitSpec)
	--if the unit exists
	if unit ~= nil then
		GW.UI.group[i]:SetEnabled(true)
		--update name
		GW.UI.group[i].name:SetText(unit.name)
		if unit.calling ~= nil then
			GW.UI.group[i].name:SetFontColor(GW.callings[unit.calling].r, GW.callings[unit.calling].g, GW.callings[unit.calling].b)
		end
		
		--update health
		if unit.health then GW.unitStats[i].health = unit.health end
		if unit.healthMax then GW.unitStats[i].healthMax = unit.healthMax end
		if not GW.unitStats[i].health then GW.unitStats[i].health = defaultValue end
		if not GW.unitStats[i].healthMax then GW.unitStats[i].healthMax = defaultValue end
		--set healthbar width
		local width = (GW.unitStats[i].health / GW.unitStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
		if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
		GW.UI.group[i].healthbar:SetWidth(width)
		
		--update role
		if unit.role ~= nil then
			GW.UI.group[i].role:SetAlpha(1)
			GW.UI.group[i].role:SetTexture("Rift", GW.icons[unit.role])
		else
			GW.UI.group[i].role:SetAlpha(0)
		end
		
		--update absorb
		if unit.absorb then GW.unitStats[i].absorb = unit.absorb end
		if not GW.unitStats[i].absorb then GW.unitStats[i].absorb = 0 end
		--set absorbbar width
		width = (GW.unitStats[i].absorb / GW.unitStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
		if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
		GW.UI.group[i].absorbbar:SetWidth(width)
		
		--update mana
		if unit.mana then GW.unitStats[i].mana = unit.mana end
		if unit.manaMax then GW.unitStats[i].manaMax = unit.manaMax end
		if not GW.unitStats[i].mana then GW.unitStats[i].mana = defaultValue end
		if not GW.unitStats[i].manaMax then GW.unitStats[i].manaMax = defaultValue end
		--update energy
		if unit.energy then GW.unitStats[i].energy = unit.energy end
		if unit.energyMax then GW.unitStats[i].energyMax = unit.energyMax end
		if not GW.unitStats[i].energy then GW.unitStats[i].energy = defaultValue end
		if not GW.unitStats[i].energyMax then GW.unitStats[i].energyMax = defaultValue end
		--set manabar color and width
		if unit.calling	== "warrior" then
			GW.UI.group[i].manabar:SetBackgroundColor(1, 1, 0)
			width = (GW.unitStats[i].energy / GW.unitStats[i].energyMax) * (GW.settings.width-(2*GW.settings.padding))
			if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
			GW.UI.group[i].manabar:SetWidth(width)
		elseif unit.calling == "rogue" then
			GW.UI.group[i].manabar:SetBackgroundColor(1, 0, 1)
			width = (GW.unitStats[i].energy / GW.unitStats[i].energyMax) * (GW.settings.width-(2*GW.settings.padding))
			if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
			GW.UI.group[i].manabar:SetWidth(width)
		elseif unit.calling == "mage" or unit.calling == "cleric" then
			GW.UI.group[i].manabar:SetBackgroundColor(0, 0, 1)
			width = (GW.unitStats[i].mana / GW.unitStats[i].manaMax) * (GW.settings.width-(2*GW.settings.padding))
			if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
			GW.UI.group[i].manabar:SetWidth(width)
		end
		GW.UI.group[i].frame:SetAlpha(1)
		
		--update offline
		if unit.offline then
			--group member is offline, set alpha to 0.2
			GW.UI.group[i].frame:SetAlpha(0.20)
			GW.UI.group[i].targetbar:SetWidth(0)
			GW.UI.group[i].tabsorbbar:SetWidth(0)
			GW.unitsOffline[i] = true
		else
			--group member is online.
			--set a value for no target
			GW.UI.group[i].targetname:SetText("")
			GW.UI.group[i].targetbar:SetWidth(0)
			GW.UI.group[i].tabsorbbar:SetWidth(0)
			
			--if there is a target
			local targetID = LibSRM.Group.Target(uid)
			GW.targetStats[i].uid = targetID
			if targetID ~= nil then
				local target = Inspect.Unit.Detail(targetID)
				if target ~= nil then
					--override the value for no target
					GW.UI.group[i].targetname:SetText(target.name)
					--set target color
					if target.relation == "hostile" then
						GW.UI.group[i].targetbar:SetBackgroundColor(1, 0, 0)
					elseif target.relation == "friendly" then
						GW.UI.group[i].targetbar:SetBackgroundColor(0, 1, 0)
					else
						--neutral
						GW.UI.group[i].targetbar:SetBackgroundColor(1, 1, 0)
					end
					--store the target's health if it exists
					if target.health then GW.targetStats[i].health = target.health end
					if target.healthMax then GW.targetStats[i].healthMax = target.healthMax end
					if target.absorb then GW.unitStats[i].absorb = target.absorb end
				end
				
				--store dummy values for the target's health if it doesn't exist
				if not GW.targetStats[i].health then GW.targetStats[i].health = defaultValue end
				if not GW.targetStats[i].healthMax then GW.targetStats[i].healthMax = defaultValue end
				if not GW.targetStats[i].absorb then GW.targetStats[i].absorb = 0 end
				--set targetbar width
				local width = (GW.targetStats[i].health / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].targetbar:SetWidth(width)
				--set tabsorbbar width
				width = (GW.targetStats[i].absorb / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].tabsorbbar:SetWidth(width)
			end
			GW.unitsOffline[i] = false
		end
	else
		--both failed, unit doesn't exist
		GW.resetGroupMember(i, unitSpec)
	end
end

--resets a group members frame to defaults
function GW.resetGroupMember(i, name)
	local width = GW.settings.width-(2*GW.settings.padding)
	GW.UI.group[i].name:SetText(name)
	GW.UI.group[i].name:SetFontColor(1, 1, 1)
	GW.UI.group[i].role:SetTexture("Rift", GW.icons["dps"])
	GW.UI.group[i].healthbar:SetWidth(width)
	GW.UI.group[i].absorbbar:SetWidth(0)
	GW.UI.group[i].manabar:SetWidth(width)
	GW.UI.group[i].manabar:SetBackgroundColor(0, 0, 1)
	GW.UI.group[i].targetbar:SetWidth(width)
	GW.UI.group[i].targetbar:SetBackgroundColor(1, 0, 0)
	GW.UI.group[i].tabsorbbar:SetWidth(0)
	GW.UI.group[i].targetname:SetText("")
	GW.UI.group[i].frame:SetAlpha(1)
	GW.UI.group[i]:SetEnabled(false)
end

--runs when a unit's target has changed
--unitID - the ID of the unit whoose target changed
--targetID - the ID of the unit's new target.
function GW.updateTarget(event, unitID, targetID)
	local i = GW.getUnitNum(unitID)
	if i then
		GW.doUpdateTarget(i, targetID)
	end
end

--update target helper method
function GW.doUpdateTarget(i, targetID)
	GW.targetStats[i].uid = targetID
	if targetID then
		local target = Inspect.Unit.Detail(targetID)
		--if the target exists
		if target then
			--update target's name
			GW.UI.group[i].targetname:SetText(target.name)
			--update target's color
			if target.relation == "hostile" then
				GW.UI.group[i].targetbar:SetBackgroundColor(1, 0, 0)
			elseif target.relation == "friendly" then
				GW.UI.group[i].targetbar:SetBackgroundColor(0, 1, 0)
			else
				--neutral
				GW.UI.group[i].targetbar:SetBackgroundColor(1, 1, 0)
			end
			--update target's health
			if target.health then GW.targetStats[i].health = target.health end
			if target.healthMax then GW.targetStats[i].healthMax = target.healthMax end
			if target.absorb then GW.unitStats[i].absorb = target.absorb end
		else
			--set dummy values for no target
			GW.UI.group[i].targetname:SetText("")
			GW.UI.group[i].targetbar:SetBackgroundColor(1, 0, 0)
			GW.targetStats[i].health = 0
			GW.targetStats[i].healthMax = defaultValue
			GW.targetStats[i].absorb = 0
		end
	else
		--set dummy values for no target
		GW.UI.group[i].targetname:SetText("")
		GW.UI.group[i].targetbar:SetBackgroundColor(1, 0, 0)
		GW.targetStats[i].health = 0
		GW.targetStats[i].healthMax = defaultValue
		GW.targetStats[i].absorb = 0
	end
	--store dummy values for the target's health if it doesn't exist
	if not GW.targetStats[i].health then GW.targetStats[i].health = defaultValue end
	if not GW.targetStats[i].healthMax then GW.targetStats[i].healthMax = defaultValue end
	if not GW.targetStats[i].absorb then GW.targetStats[i].absorb = 0 end
	--set targetbar width
	local width = (GW.targetStats[i].health / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
	if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
	GW.UI.group[i].targetbar:SetWidth(width)
	--set tabsorbbar width
	width = (GW.targetStats[i].absorb / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
	if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
	GW.UI.group[i].tabsorbbar:SetWidth(width)
end

--called when a unit moves
--x, y, z - the new coordinates of the units that moved. Each one is a table.
function GW.updateRange(event, x, y, z)
	local playerMoved = false
	--if the player moved
	if x[GW.playerID] then
		--update the player's coordinates
		GW.playerCoords.x = x[GW.playerID]
		GW.playerCoords.y = y[GW.playerID]
		GW.playerCoords.z = z[GW.playerID]
		playerMoved = true
	end
	if LibSRM.Grouped() then
		--for each group member
		for i=1,20 do
			local spec, uid = LibSRM.Group.Inspect(i)
			--if the group member moved
			if x[uid] then
				--update the group member's coordinates
				GW.unitCoords[i].x = x[uid]
				GW.unitCoords[i].y = y[uid]
				GW.unitCoords[i].z = z[uid]
				--update group member range
				GW.doUpdateRange(i, uid)
			--if the player moved, update regardless
			elseif playerMoved == true then
				--update group member range
				GW.doUpdateRange(i, uid)
			end
		end
	end
	--if the pet moved
	if x[GW.petID] then
		--update the pets's coordinates
		GW.unitCoords[22].x = x[GW.petID]
		GW.unitCoords[22].y = y[GW.petID]
		GW.unitCoords[22].z = z[GW.petID]
		--update pet range
		GW.doUpdateRange(22, GW.petID)
	--if the player moved, update regardless
	elseif playerMoved == true then
		--update pet range
		GW.doUpdateRange(22, GW.petID)
	end
end

--update range helper method
function GW.doUpdateRange(i, uid)
	--if both the player and the group member have coordinates set
	if GW.playerCoords.x and GW.playerCoords.z then
		if not GW.unitsOffline[i] and GW.UI.group[i].name:GetText() ~= "" then
			if GW.unitCoords[i].x and GW.unitCoords[i].z then
				--check the range between the player and the group member
				local range = ((GW.playerCoords.x - GW.unitCoords[i].x)^2)+((GW.playerCoords.z - GW.unitCoords[i].z)^2)
				if range > (GW.settings.maxrange^2) then
					--group member is out of range, set alpha to 0.2
					GW.UI.group[i].frame:SetAlpha(0.20)
					GW.unitsOutOfRange[i] = true
				else
					--group member is in range
					--if the unit isn't blocked
					if not GW.unitsBlocked[i] then
						--set the alpha to 1 (fully opaque)
						GW.UI.group[i].frame:SetAlpha(1)
					end
					GW.unitsOutOfRange[i] = false
				end
			end
		end
	end
end

--called when a unit moves behind or away from an object, blocking or unblocking the player's line-of-sight
--units - a table of units that were blocked/unblocked this frame.
function GW.updateBlocked(event, units)
	--for each unit who was blocked/unblocked
	for k, v in pairs(units) do
		local i = nil
		if k == GW.petID then i = 22
		elseif LibSRM.Grouped() then
			i = GW.geti[LibSRM.Group.UnitExists(k)]
		end
		if i then
			if v then
				--unit is bocked.
				--if the unit isn't out of range (different alpha)
				if not GW.unitsOutOfRange[i] then
					--set alpha to 0.6
					GW.UI.group[i].frame:SetAlpha(0.60)
				end
				GW.unitsBlocked[i] = true
			else
				--unit is not blocked
				GW.unitsBlocked[i] = false
			end
		end
	end
end

--called when a unit's Health value changes
--units - a table of units whose values were changed
function GW.updateHealth(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their health
			if v then GW.unitStats[i].health = v
			else GW.unitStats[i].health = defaultValue end
			--and update the healthbar width
			if GW.unitStats[i].healthMax then
				local width = (GW.unitStats[i].health / GW.unitStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].healthbar:SetWidth(width)
			end
		else
			--the unit is not a group member, check if it is a group member's target.
			if LibSRM.Grouped() then
				for i=1,20 do
					GW.doUpdateHealth(i, k, v)
				end
				if GW.settings.petVisible then
					GW.doUpdateHealth(22, k, v)
				end
			else
				GW.doUpdateHealth(21, k, v)
				GW.doUpdateHealth(22, k, v)
			end
		end
	end
end

--update health helper method
function GW.doUpdateHealth(i, k, v)
	--only need to handle target health, unit health is handled above
	if GW.targetStats[i].uid == k then
		if v then GW.targetStats[i].health = v
		else GW.targetStats[i].health = defaultValue end
		if GW.targetStats[i].healthMax then
			local width = (GW.targetStats[i].health / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
			if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
			GW.UI.group[i].targetbar:SetWidth(width)
		end
	end
end

--called when a unit's Max Health value changes
--units - a table of units whose values were changed
function GW.updateHealthMax(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their max health
			if v then GW.unitStats[i].healthMax = v
			else GW.unitStats[i].healthMax = defaultValue end
			--and update the healthbar width
			if GW.unitStats[i].health then
				local width = (GW.unitStats[i].health / GW.unitStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].healthbar:SetWidth(width)
			end
		else
			--the unit is not a group member, check if it is a group member's target.
			if LibSRM.Grouped() then
				for i=1,20 do
					GW.doUpdateHealthMax(i, k, v)
				end
				if GW.settings.petVisible then
					GW.doUpdateHealthMax(22, k, v)
				end
			else
				GW.doUpdateHealthMax(21, k, v)
				GW.doUpdateHealthMax(22, k, v)
			end
		end
	end
end

--update health max helper method
function GW.doUpdateHealthMax(i, k, v)
	if GW.targetStats[i].uid == k then
		if v then GW.targetStats[i].healthMax = v
		else GW.targetStats[i].healthMax = defaultValue end
		if GW.targetStats[i].health then
			local width = (GW.targetStats[i].health / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
			if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
			GW.UI.group[i].targetbar:SetWidth(width)
		end
	end
end

--called when a unit's Mana value changes
--units - a table of units whose values were changed
function GW.updateMana(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their mana
			if v then GW.unitStats[i].mana = v
			else GW.unitStats[i].mana = defaultValue end
			--and update the manabar width
			if GW.unitStats[i].manaMax then
				local width = (GW.unitStats[i].mana / GW.unitStats[i].manaMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].manabar:SetWidth(width)
			end
		end
	end
end

--called when a unit's Max Mana value changes
--units - a table of units whose values were changed
function GW.updateManaMax(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their max mana
			if v then GW.unitStats[i].manaMax = v
			else GW.unitStats[i].manaMax = defaultValue end
			--and update the manabar width
			if GW.unitStats[i].mana then
				local width = (GW.unitStats[i].mana / GW.unitStats[i].manaMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].manabar:SetWidth(width)
			end
		end
	end
end

--called when a unit's Energy value changes
--units - a table of units whose values were changed
function GW.updateEnergy(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their energy
			if v then GW.unitStats[i].energy = v
			else GW.unitStats[i].energy = defaultValue end
			--and update the manabar width
			if GW.unitStats[i].energyMax then
				local width = (GW.unitStats[i].energy / GW.unitStats[i].energyMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].manabar:SetWidth(width)
			end
		end
	end
end

--called when a unit's Max Energy value changes
--units - a table of units whose values were changed
function GW.updateEnergyMax(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their max energy
			if v then GW.unitStats[i].energyMax = v
			else GW.unitStats[i].energyMax = defaultValue end
			--and update the manabar width
			if GW.unitStats[i].energy then
				local width = (GW.unitStats[i].energy / GW.unitStats[i].energyMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].manabar:SetWidth(width)
			end
		end
	end
end

--called when a buff on a unit changes.
--unit - the unit whose buff(s) changed
--buffs - a table of buffs that changed on that unit
function GW.updateBuffs(event, unit, buffs)
	--if addon was loaded
	if GW.buttons.buttons and GW.buttons.timers then
		local i = GW.getUnitNum(unit)
		if i and buffs then
			--be sure debuff information exists for this unit
			if GW.debuffTracked[i] == nil then
				GW.debuffTracked[i] = {}
			end
			--be sure buff information exists for this unit
			if GW.buffTracked[i] == nil then
				GW.buffTracked[i] = {}
			end
			--first, remove all changed buffs
			for k, v in pairs(buffs) do
				GW.debuffTracked[i][k] = nil
				if GW.buffTracked[i][k] then
					GW.buffTracked[i][k].remaining = 0
					GW.buffTracked[i][k] = nil
				end
			end
			--inspect the buffs that changed on that unit
			local buffList = Inspect.Buff.Detail(unit, buffs)
			--for each buff
			for k, v in pairs(buffList) do
				--make sure the caster is the player
				if v.remaining then
					--and for each timer...
					for n=1,GW.settings.timers do
						local doThis = false
						if GW.buttons.timers[n].left.buff then
							--check if the name of the buff matches the one tracked by the timer
							if v.name == GW.buttons.timers[n].left.buff then
								doThis = true
							end
						elseif v.caster == GW.playerID then
							--check if the ability for that timer is the cause of the buff
							local abilityName = GW.getShowName(GW.buttons.timers[n].left)
							if abilityName ~= nil and abilityName ~= "" and GW.abilityIDs[abilityName] then
								if v.abilityNew == GW.abilityIDs[abilityName] then
									doThis = true
								end
							end
						end
						if doThis == true then
							--hopefully the it won't be a debuff, but if it us, change the color.
							if v.debuff == nil then
								GW.UI.group[i].timerbar[n]:SetBackgroundColor(0, 1, 1)
							else
								GW.UI.group[i].timerbar[n]:SetBackgroundColor(1, 0, 1)
							end
							
							--and record the buff's information so that the timer can be updated each frame.
							if GW.buffTimers[i] == nil then
								GW.buffTimers[i] = {}
							end
							if GW.buffTracked[i][k] == nil then
								GW.buffTracked[i][k] = {}
							end
							GW.buffTracked[i][k].remaining = v.remaining
							GW.buffTracked[i][k].duration = v.duration
							GW.buffTimers[i][n] = GW.buffTracked[i][k]
						end
					end
					for n=1,GW.maxButtons do
						local doThis = false
						if GW.buttons.buttons[n].left.buff then
							if v.name == GW.buttons.buttons[n].left.buff then
								doThis = true
							end
						elseif v.caster == GW.playerID and GW.buttons.buttons[n].left.fade == "buffed" then
							local abilityName = GW.getShowName(GW.buttons.buttons[n].left)
							if abilityName ~= nil and abilityName ~= "" and GW.abilityIDs[abilityName] then
								if v.abilityNew == GW.abilityIDs[abilityName] then
									doThis = true
								end
							end
						end
						if doThis == true then
							if GW.abilityBuffs[i] == nil then
								GW.abilityBuffs[i] = {}
							end
							if GW.buffTracked[i][k] == nil then
								GW.buffTracked[i][k] = {}
							end
							GW.buffTracked[i][k].remaining = v.remaining
							GW.buffTracked[i][k].duration = v.duration
							GW.buffTracked[i][k].icon = v.icon
							GW.abilityBuffs[i][n] = GW.buffTracked[i][k]
						end
					end
				end
				if v.curse or v.disease or v.poison then
					--re-add debuff information if the buff still exists
					GW.debuffTracked[i][k] = true
				end
			end
		end
	end
end

--called when one of the player's ability cooldowns changes.
--abilities - a table of abilities whoose cooldowns have changed
function GW.updateAbilities(event, abilities)
	--if addon was loaded
	if GW.buttons.buttons then
		--for each ability
		for k, v in pairs(abilities) do
			--for each button...
			for n=1,GW.maxButtons do
				--...check if the ability for that button is the ability whose cooldown changed
				local height = 0
				--make sure we're not supposed to be tracking a buff with this button
				if not GW.buttons.buttons[n].left.buff then
					local abilityName = GW.getShowName(GW.buttons.buttons[n].left)
					if abilityName ~= nil and abilityName ~= "" and GW.abilityIDs[abilityName] then
						if k == GW.abilityIDs[abilityName] then
							--ability was for this button, record the cooldown's information so that the overlay can be updated each frame.
							local width = 0
							GW.abilityCooldowns[n] = {}
							GW.abilityCooldowns[n].remaining = v
							
							if v > 0 then --cooldown begin
								--height = GW.settings.button
								GW.abilityCooldowns[n].duration = v
							end
						end
					end
				end
			end
		end
	end
end

--called when an ability becomes usable/unusable
function GW.updateUnusable(event, abilities)
	--if addon was loaded
	if GW.buttons.buttons then
		--for each ability
		for k, v in pairs(abilities) do
			--for each button...
			for n=1,GW.maxButtons do
				--make sure we're not supposed to be tracking a buff with this button
				if not GW.buttons.buttons[n].left.buff then
					local abilityName = GW.getShowName(GW.buttons.buttons[n].left)
					if abilityName ~= nil and abilityName ~= "" and GW.abilityIDs[abilityName] then
						if k == GW.abilityIDs[abilityName] then
							if v then
								GW.abilityUnusable[n] = nil
							else
								GW.abilityUnusable[n] = k
							end
						end
					end
				end
			end
		end
	end
end

--called when a unit gains aggro
--units - a table of units whoose aggro has change
function GW.updateAggro(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--if the unit has aggro, set the aggro frame texture.
			if v then
				GW.UI.group[i].frameBG:SetTexture(addon.identifier, "img/frameRed.png")
			else
				GW.UI.group[i].frameBG:SetTexture(addon.identifier, "img/frame.png")
			end
		end
	end
end

--called when a unit's damage absorption value changes
--units - a table of units whose values were changed
function GW.updateAbsorb(event, units)
	--for each unit changed
	for k, v in pairs(units) do
		local i = GW.getUnitNum(k)
		--if the unit is a group member
		if i then
			--update their damage absorb
			if v then GW.unitStats[i].absorb = v
			else GW.unitStats[i].absorb = 0 end
			--and update the absorbbar width
			if GW.unitStats[i].healthMax then
				local width = (GW.unitStats[i].absorb / GW.unitStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
				if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
				GW.UI.group[i].absorbbar:SetWidth(width)
			end
		else
			--the unit is not a group member, check if it is a group member's target.
			if LibSRM.Grouped() then
				for i=1,20 do
					GW.doUpdateAbsorb(i, k, v)
				end
				if GW.settings.petVisible then
					GW.doUpdateAbsorb(22, k, v)
				end
			else
				GW.doUpdateAbsorb(21, k, v)
				GW.doUpdateAbsorb(22, k, v)
			end
		end
	end
end

--update absorb helper method
function GW.doUpdateAbsorb(i, k, v)
	if GW.targetStats[i].uid == k then
		--update their damage absorb
		if v then GW.targetStats[i].absorb = v
		else GW.targetStats[i].absorb = 0 end
		--and update the tabsorbbar width
		if GW.targetStats[i].healthMax then
			local width = (GW.targetStats[i].absorb / GW.targetStats[i].healthMax) * (GW.settings.width-(2*GW.settings.padding))
			if width > (GW.settings.width-(2*GW.settings.padding)) then width = (GW.settings.width-(2*GW.settings.padding)) end
			GW.UI.group[i].tabsorbbar:SetWidth(width)
		end
	end
end

--called from onUpdate in main.lua. Updates the width of the timerbars and the height of the cooldown overlays.
--seconds - the time that has passed since last update (in seconds)
function GW.updateTimers(seconds)
	--reset all cooldowns
	for n=1,GW.maxButtons do
		if GW.UI.group[1].buttonBG[n]:GetHeight() > 0 then
			for i=1,22 do
				GW.UI.group[i].buttonbar[n]:SetHeight(0)
			end
		end
	end
	--for each ability on cooldown
	for k, v in pairs(GW.abilityCooldowns) do
		--update the remaining time
		v.remaining = v.remaining - seconds
		GW.abilityCooldowns[k].remaining = v.remaining --update global too
		
		--calculate the new height for the cooldown overlay.
		local height = 0
		if v.remaining > 0 then
			--ability on cooldown
			height = (v.remaining / v.duration) * (GW.settings.button)
		else
			GW.abilityCooldowns[k].remaining = 0
			GW.abilityCooldowns[k] = nil
		end
		--then for each frame, set the overlay to display the cooldown (by height)
		if GW.UI.group[1].buttonBG[k]:GetHeight() > 0 then
			if GW.UI.group[1].buttonbar[k]:GetHeight() ~= math.floor(height) then
				for i=1,22 do
					--get the ability ID for this button
					local id = GW.getShow(GW.buttons.buttons[k].left)
					--update the cooldown
					GW.UI.group[i].buttonbar[k]:SetHeight(math.floor(height))
				end
			end
		end
	end
	local clean = {}
	--for each unit with a buff
	for unit, buffs in pairs(GW.buffTracked) do
		--for each buff on that unit
		for k, v in pairs(buffs) do
			--update the remaining time
			v.remaining = v.remaining - seconds
			
			--clean up if expired
			if v.remaining <= 0 then
				GW.buffTracked[unit][k].remaining = 0
				GW.buffTracked[unit][k] = nil
				if GW.tableSize(GW.buffTracked[unit]) == 0 then
					GW.buffTracked[unit] = nil
					clean[unit] = true
				end
			end
		end
	end
	--for each unit with a buff
	for unit, buffs in pairs(GW.abilityBuffs) do
		--for each buff on that unit
		for k, v in pairs(buffs) do
			if v.remaining > 0 then
				if GW.buttons.buttons[k].left.buff then
					--button is buff watcher, set the height based on duration
					local height = (v.remaining / v.duration) * (GW.settings.button)
					if GW.UI.group[1].buttonBG[k]:GetHeight() > 0 then
						GW.UI.group[unit].buttonbar[k]:SetHeight(math.floor(GW.settings.button - height))
					end
					--update icon
					if v.icon then
						GW.UI.group[unit].buttonBG[k]:SetTexture("Rift", v.icon)
					else
						GW.UI.group[unit].buttonBG[k]:SetTexture(addon.identifier, "img/buttonbg.png")
					end
				else
					--button set as "Dim when buffed", dim the button
					if GW.UI.group[1].buttonBG[k]:GetHeight() > 0 then
						GW.UI.group[unit].buttonbar[k]:SetHeight(GW.settings.button)
					end
				end
			else
				--clean up if expired
				GW.abilityBuffs[unit][k] = nil
				--close icon if buff tracker
				if GW.buttons.buttons[k].left.buff then
					GW.UI.group[unit].buttonBG[k]:SetTexture(addon.identifier, "img/buttonbg.png")
				end
			end
		end
		if clean[unit] then
			GW.abilityBuffs[unit] = nil
		end
	end
	--for each unit with a buff
	for unit, buffs in pairs(GW.buffTimers) do
		--for each buff on that unit
		for k, v in pairs(buffs) do
			--set the new width of the timerbar for that unit
			local width = (v.remaining / v.duration) * (GW.settings.width-(2*GW.settings.padding))
			GW.UI.group[unit].timerbar[k]:SetWidth(math.floor(width))
			
			--clean up if expired
			if v.remaining == 0 then
				GW.buffTimers[unit][k] = nil
			end
		end
		if clean[unit] then
			GW.buffTimers[unit] = nil
		end
	end
	--dim out cleansing spells when there's no debuff to cleanse
	if LibSRM.Grouped() then
		for i=1,20 do
			GW.doUpdateTimers(i)
		end
		if GW.settings.petVisible then
			GW.doUpdateTimers(22)
		end
	else
		GW.doUpdateTimers(21)
		GW.doUpdateTimers(22)
	end
end

--update timers helper method
function GW.doUpdateTimers(i)
	--if the unit does not have a cleaseable debuff
	if GW.tableSize(GW.debuffTracked[i]) == 0 then
		--for each button that is a cleansing spell
		for k, v in pairs(GW.cleaseButtons) do
			--if button is visible
			if GW.UI.group[1].buttonBG[k]:GetHeight() > 0 then
				--unusuable on this target, cover with cooldown overlay
				GW.UI.group[i].buttonbar[k]:SetHeight(GW.settings.button)
			end
		end
	end
	for k, v in pairs(GW.abilityUnusable) do
		if v and GW.buttons.buttons[k].left.fade == "usable" then
			--if button is visible
			if GW.UI.group[1].buttonBG[k]:GetHeight() > 0 then
				--ability is unusable, cover with cooldown overlay
				GW.UI.group[i].buttonbar[k]:SetHeight(GW.settings.button)
			end
		end
	end
end

--stores all of the player's abilities in a global variable
--so that we don't have to inspect them every frame.
function GW.initAbilities()
	local newList = Inspect.Ability.New.Detail(Inspect.Ability.New.List())
	for k, v in pairs(newList) do
		--add the ability to the list
		GW.abilityList[k] = v
		--record the ability's id by name
		GW.abilityIDs[v.name] = k
	end
	if GW.countFixData > 0 then
		--role was changed, need to update buttons with new abilities
		if not Inspect.System.Secure() then
			Command.System.Watchdog.Quiet()
			GW.fixButtons()
			GW.countFixData = 0
		end
	end
end

function GW.initFade(n)
	local fade = GW.buttons.buttons[n].left.fade
	if fade == "buffed" then
		GW.cleaseButtons[n] = nil
		--if grouped
		if LibSRM.Grouped() then
			--for each group member
			for i=1,20 do
				--update buff info for group member
				local id = Inspect.Unit.Lookup(GW.spec[i])
				if id ~= nil then
					GW.updateBuffs(nil, id, Inspect.Buff.List(GW.spec[i]))
				end
			end
			--update buff info for pet frame
			if GW.settings.petVisible and GW.petID then
				GW.updateBuffs(nil, GW.petID, Inspect.Buff.List("player.pet"))
			end
		else
			--update buff info for player frame
			GW.updateBuffs(nil, GW.playerID, Inspect.Buff.List("player"))
			--update buff info for pet frame
			if GW.petID then
				GW.updateBuffs(nil, GW.petID, Inspect.Buff.List("player.pet"))
			end
		end
	elseif fade == "debuffed" then
		GW.cleaseButtons[n] = true
		--if button is visible
		if GW.UI.group[1].buttonBG[n]:GetHeight() > 0 then
			--if the unit does not have a cleaseable debuff
			if GW.tableSize(GW.debuffTracked[i]) == 0 then
				--for each frame
				for i=1,22 do
					--unusuable on this target, cover with cooldown overlay
					GW.UI.group[i].buttonbar[n]:SetHeight(GW.settings.button)
				end
			end
		end
	elseif fade == "usable" then
		GW.cleaseButtons[n] = nil
		--if the ability is unusable
		local id = GW.buttons.buttons[n].left.default.id
		if GW.abilityList[id] ~= nil then
			if GW.abilityList[id].unusable then
				--ability unusable
				GW.abilityUnusable[n] = id
				--if button is visible
				if GW.UI.group[1].buttonBG[n]:GetHeight() > 0 then
					for i=1,22 do
						--unusable on any target, cover with cooldown overlay
						GW.UI.group[i].buttonbar[n]:SetHeight(GW.settings.button)
					end
				end
			end
		else
			local ability = Inspect.Ability.New.Detail(id)
			if ability ~= nil then
				if ability.unusable then
					--ability unusable
					GW.abilityUnusable[n] = id
					--if button is visible
					if GW.UI.group[1].buttonBG[n]:GetHeight() > 0 then
						for i=1,22 do
							--unusable on any target, cover with cooldown overlay
							GW.UI.group[i].buttonbar[n]:SetHeight(GW.settings.button)
						end
					end
				end
			end
		end
	else --fade == "nil" then
		GW.cleaseButtons[n] = nil
		for i=1,22 do
			GW.UI.group[i].buttonbar[n]:SetHeight(0)
		end
	end
end

--return the index of the unit using in GW.UI.group[i] and other data
function GW.getUnitNum(unitID)
	if unitID == GW.petID then
		return 22
	elseif LibSRM.Grouped() then
		--make sure the unit is a group member
		return GW.geti[LibSRM.Group.UnitExists(unitID)]
	elseif unitID == GW.playerID then
		return 21
	end
	return nil
end

--------------------------------------------------------------------------------------------
-- Attach events for this script file. -----------------------------------------------------
--------------------------------------------------------------------------------------------

--events on joining or leaving a group
Command.Event.Attach(Event.SafesRaidManager.Player.Join, GW.updateGroup, "updateGroup")
Command.Event.Attach(Event.SafesRaidManager.Player.Leave, GW.updateGroup, "updateGroup")
--events on group member change:
Command.Event.Attach(Event.SafesRaidManager.Group.Join, GW.updateViaSpec, "updateViaSpec")
Command.Event.Attach(Event.SafesRaidManager.Group.Leave, GW.updateViaSpec, "updateViaSpec")
Command.Event.Attach(Event.SafesRaidManager.Group.Reload, GW.updateViaSpec, "updateViaSpec")
Command.Event.Attach(Event.SafesRaidManager.Group.Change, GW.updateViaSpec, "updateViaSpec")
Command.Event.Attach(Event.SafesRaidManager.Group.Offline, function(event, uid) GW.updateViaSpec(event, uid, LibSRM.Group.UnitExists(uid)) end, "updateOffline")
--events on group member info becomming available
Command.Event.Attach(Event.Unit.Availability.Full, GW.updateAvailable, "updateAvailable")
--events on pet changing
Command.Event.Attach(Event.SafesRaidManager.Player.Pet.Add, GW.updateGroup, "updateGroup")
Command.Event.Attach(Event.SafesRaidManager.Player.Pet.Remove, GW.updateGroup, "updateGroup")

--events on group member's target change:
Command.Event.Attach(Event.SafesRaidManager.Group.Target, GW.updateTarget, "updateTarget")
Library.LibUnitChange.Register("player.target")
Command.Event.Attach(Event.LibUnitChange.player.target.Change, function(event, unitid) GW.doUpdateTarget(21, unitid) end, "updateTarget")
Library.LibUnitChange.Register("player.pet.target")
Command.Event.Attach(Event.LibUnitChange.player.pet.target.Change, function(event, unitid) GW.doUpdateTarget(22, unitid) end, "updateTarget")

--events on group members (or player) moving
Command.Event.Attach(Event.Unit.Detail.Coord, GW.updateRange, "updateRange")

--events on group members moving behind something, blocking line-of-sight
Command.Event.Attach(Event.Unit.Detail.Blocked, GW.updateBlocked, "updateBlocked")

--events on unit's health, mana, or energy changing. This may be from a group member, or an enemy.
Command.Event.Attach(Event.Unit.Detail.Health, GW.updateHealth, "updateCombat")
Command.Event.Attach(Event.Unit.Detail.HealthMax, GW.updateHealthMax, "updateCombat")
Command.Event.Attach(Event.Unit.Detail.Mana, GW.updateMana, "updateCombat")
Command.Event.Attach(Event.Unit.Detail.ManaMax, GW.updateManaMax, "updateCombat")
Command.Event.Attach(Event.Unit.Detail.Energy, GW.updateEnergy, "updateCombat")
Command.Event.Attach(Event.Unit.Detail.EnergyMax, GW.updateEnergyMax, "updateCombat")

--events on ability cooldowns. This will tell us when an ability starts and ends it cooldown.
Command.Event.Attach(Event.Ability.New.Cooldown.Begin, GW.updateAbilities, "updateAbilities")
Command.Event.Attach(Event.Ability.New.Cooldown.End, GW.updateAbilities, "updateAbilities")
--events on abilities becomming usable/unusable.
Command.Event.Attach(Event.Ability.New.Usable.False, GW.updateUnusable, "updateUnusable")
Command.Event.Attach(Event.Ability.New.Usable.True, GW.updateUnusable, "updateUnusable")

--events on buff durations. This will tell us when a buff starts, ends, or is refreshed
Command.Event.Attach(Event.Buff.Add, GW.updateBuffs, "updateBuffs")
Command.Event.Attach(Event.Buff.Change, GW.updateBuffs, "updateBuffs")
Command.Event.Attach(Event.Buff.Remove, GW.updateBuffs, "updateBuffs")

--events on aggro values. This will tell us when a unit gains aggro
Command.Event.Attach(Event.Unit.Detail.Aggro, GW.updateAggro, "updateAggro")

--events on absorption. This will tell us when a unit has damage absorption
Command.Event.Attach(Event.Unit.Detail.Absorb, GW.updateAbsorb, "updateAbsorb")

--events on ability changes. Keep the ability list updated.
Command.Event.Attach(Event.Ability.New.Add, GW.initAbilities, "initAbilities")
Command.Event.Attach(Event.Ability.New.Remove, GW.initAbilities, "initAbilities")